/*  
 *
 *  (c) Computall Services 1999/2000
 *  url:  http://www.ncf.ca/~aa571/index.html
 *  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */



#include <stdio.h>
#define BYTE unsigned char


// de-interleave one pack
int cdg_deinterleave(unsigned char *x)
{
// save the 8 copies of the packs
static unsigned char d[25][9];
int i,j;

	//put the pack of data into the queue to be deinterleaved
	for (i=0;i<24;i++)
		{
		d[i][0] = x[i] & 0x3f;
		}

	// de-interleave one pack
	x[ 0] = d[ 0][7];
	x[ 1] = d[18][5];
	x[ 2] = d[ 5][2];
	x[ 3] = d[23][0];
	x[ 4] = d[ 4][3];
	x[ 5] = d[ 2][5];
	x[ 6] = d[ 6][1];
	x[ 7] = d[ 7][0];
	x[ 8] = d[ 8][7];
	x[ 9] = d[ 9][6];
	x[10] = d[10][5];
	x[11] = d[11][4];
	x[12] = d[12][3];
	x[13] = d[13][2];
	x[14] = d[14][1];
	x[15] = d[15][0];
	x[16] = d[16][7];
	x[17] = d[17][6];
	x[18] = d[ 1][6];
	x[19] = d[19][4];
	x[20] = d[20][3];
	x[21] = d[21][2];
	x[22] = d[22][1];
	x[23] = d[ 3][4];

	// move the packs along the queue
	for (i=6;i>=0;i--)
		for (j=0;j<24;j++)
			d[j][i+1] = d[j][i];
return(0);
}

// interleave one pack
int cdg_interleave(unsigned char *x)
{
// save the 8 copies of the packs
static unsigned char d[25][9];
int i,j;

	// put the pack of data into the queue to be interleaved
	for (i=0;i<24;i++)
		{
		d[i][0] = x[i] & 0x3f;
		}
	
	// interleave one pack
	x[ 0] = d[ 0][0];
	x[ 1] = d[18][1];
	x[ 2] = d[ 5][2];
	x[ 3] = d[23][3];
	x[ 4] = d[ 4][4];
	x[ 5] = d[ 2][5];
	x[ 6] = d[ 6][6];
	x[ 7] = d[ 7][7];
	x[ 8] = d[ 8][0];
	x[ 9] = d[ 9][1];
	x[10] = d[10][2];
	x[11] = d[11][3];
	x[12] = d[12][4];
	x[13] = d[13][5];
	x[14] = d[14][6];
	x[15] = d[15][7];
	x[16] = d[16][0];
	x[17] = d[17][1];
	x[18] = d[ 1][2];
	x[19] = d[19][3];
	x[20] = d[20][4];
	x[21] = d[21][5];
	x[22] = d[22][6];
	x[23] = d[ 3][7];

	// move the pack along the queue
	for (i=6;i>=0;i--)
		for (j=0;j<24;j++)
			d[j][i+1] = d[j][i];
return(0);
}

